JSB.newAddon = function(mainPath){
  //以下为非官方 Start
  JSB.require('TipViewController');
  //以上为非官方 End
  var newAddonClass = JSB.defineClass('AutoTitle : JSExtension', /*Instance members*/{
    //Window initialize
    sceneWillConnect: function() {
        self.webController = WebViewController.new();

        //以下为非官方 Start
        self.tipController = TipViewController.new();
        //以上为非官方 End
    },
    //Window disconnect
    sceneDidDisconnect: function() {
    },
    //Window resign active
    sceneWillResignActive: function() {
    },
    //Window become active
    sceneDidBecomeActive: function() {
    },
    notebookWillOpen: function(notebookid) {
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onProcessExcerptText:','ProcessNewExcerpt');
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onProcessExcerptText:','ChangeExcerptRange');
      self.autotitle = NSUserDefaults.standardUserDefaults().objectForKey('marginnote_autotitle');

      //以下为非官方 Start
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onPopupMenuOnNote:','PopupMenuOnNote');
      NSTimer.scheduledTimerWithTimeInterval(0.2,false,function(){
        var tip_on = NSUserDefaults.standardUserDefaults().objectForKey('marginnote_tip_on');
        if(Application.sharedInstance().studyController(self.window).studyMode < 3 && tip_on == true){// Not support in card deck mode
          Application.sharedInstance().studyController(self.window).view.addSubview(self.tipController.view);
          self.layoutTipController();
          Application.sharedInstance().studyController(self.window).refreshAddonCommands();
          NSTimer.scheduledTimerWithTimeInterval(0.2,false,function(){ 
            Application.sharedInstance().studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
        }
      });
      //以上为非官方 End
    },
    notebookWillClose: function(notebookid) {
      NSNotificationCenter.defaultCenter().removeObserverName(self,'ProcessNewExcerpt');
      NSNotificationCenter.defaultCenter().removeObserverName(self,'ChangeExcerptRange');

      //以下为非官方 Start
      NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnNote');
      NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnSelection');
      //End
    },
    documentDidOpen: function(docmd5) {
    },
    documentWillClose: function(docmd5) {
    },
    controllerWillLayoutSubviews: function(controller) {
    },
    queryAddonCommandStatus: function() {
      if(Application.sharedInstance().studyController(self.window).studyMode < 3)
        return {image:'title.png',object:self,selector:'toggleAutoTitle:',checked:(self.autotitle?true:false)};
      return null;
    },
    //Clicking note
    onProcessExcerptText: function(sender){
      if(!Application.sharedInstance().checkNotifySenderInWindow(sender,self.window))return;//Don't process message from other window
      if(!self.autotitle)return;
      var noteid = sender.userInfo.noteid;
      var note = Database.sharedInstance().getNoteById(noteid);

      //以下为非官方 Start
      var limitNo = 10;
      try {
        if(parseInt(self.tipController.navigationItem.title) > 0 && parseInt(self.tipController.navigationItem.title) < 250)
        {
          limitNo = parseInt(self.tipController.navigationItem.title);
        }
        else{
          limitNo = 10;
        }
        
      }
      catch(err) {
       // Application.sharedInstance().showHUD("请输入整数",self.window,2);
        limitNo = 10;
      }
      //
      if(note && note.excerptText && note.excerptText.length > 0 && note.excerptText.length <= limitNo && !note.groupNoteId){
        var timerCount = 0;
        NSTimer.scheduledTimerWithTimeInterval(1,true,function(timer){
          var text = note.excerptText.split("**").join("");
          if(text && text.length){
            UndoManager.sharedInstance().undoGrouping('AutoTitle',note.notebookId,function(){
              note.noteTitle = text;
              note.excerptText = '';
              Database.sharedInstance().setNotebookSyncDirty(note.notebookId);
            });
            NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('RefreshAfterDBChange',self,{topicid:note.notebookId});
          }
          timerCount++;
          if(timerCount >= 4){
            timer.invalidate();
          }
        });
      }
    },
    toggleAutoTitle: function(sender) {
      var lan = NSLocale.preferredLanguages().length?NSLocale.preferredLanguages()[0].substring(0,2):'en';
      if(self.autotitle){
        self.autotitle = false;
        if(lan == 'zh')
          Application.sharedInstance().showHUD('自动设置标题已关闭',self.window,2);
        else
          Application.sharedInstance().showHUD('Auto title is turned off',self.window,2);
      }
      else{
        self.autotitle = true;
        if(lan == 'zh')
          Application.sharedInstance().showHUD('创建摘录后，摘录内容将自动被设置为笔记标题',self.window,2);
        else
          Application.sharedInstance().showHUD('After creating an excerpt, the excerpt will be automatically set as the note title',self.window,2);
      }
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.autotitle,'marginnote_autotitle');
      Application.sharedInstance().studyController(self.window).refreshAddonCommands();

      //以下为非官方 Start
      if(self.tipController.view.window){
        self.tipController.view.removeFromSuperview();
        NSUserDefaults.standardUserDefaults().setObjectForKey(false,'marginnote_tip_on');
      }
      else{
        Application.sharedInstance().studyController(self.window).view.addSubview(self.tipController.view);        
        self.layoutTipController();
        NSUserDefaults.standardUserDefaults().setObjectForKey(true,'marginnote_tip_on');
        NSTimer.scheduledTimerWithTimeInterval(0.2,false,function(){ 
          Application.sharedInstance().studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
        });
      }
      Application.sharedInstance().studyController(self.window).refreshAddonCommands();
      //End
    },
  }, /*Class members*/{
    addonDidConnect: function() {
    },
    addonWillDisconnect: function() {
    },
    applicationWillEnterForeground: function() {
    },
    applicationDidEnterBackground: function() {
    },
    applicationDidReceiveLocalNotification: function(notify) {
    },
  });
  newAddonClass.prototype.layoutTipController = function(){
    var frame = Application.sharedInstance().studyController(this.window).view.bounds;
    var width = frame.width > 30?(30 + (frame.width - 30)/2):30;
    this.tipController.view.frame = {x:(frame.width-width - 50),y:10,width:width/2,height:30};
  };
  return newAddonClass;
};

